package rocks.zipcode.io.quiz4.collections;

import java.util.TreeSet;

/**
 * @author leon on 11/12/2018.
 */
public class ComparableTreeSet<T extends Comparable> extends TreeSet<T> implements Comparable<ComparableTreeSet<T>> {
    private TreeSet<T> treeSet;

    public ComparableTreeSet(T... arr) {
        this.treeSet = new TreeSet<>();
        for(T t: arr){
            treeSet.add(t);
        }

    }

    public ComparableTreeSet() {
        this.treeSet = new TreeSet<>();
    }

    public int compareTo(ComparableTreeSet<T> o) {
        return this.treeSet.first().compareTo(o.treeSet.first());
    }

    @Override
    public String toString(){
        StringBuilder builder = new StringBuilder();
        builder.append("[");

        for (T t:this.treeSet){
            builder.append(t.toString());
            builder.append(", ");
        }
        builder.deleteCharAt(builder.length()-1);
        builder.deleteCharAt(builder.length()-1);

        return builder + "]";
    }


}
