package rocks.zipcode.io.quiz4.collections;

import rocks.zipcode.io.quiz4.objectorientation.Student;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * @author leon on 11/12/2018.
 */
public class ZipCodeWilmington {
    private ArrayList<Student> zipCoders;
    private double totalStudyTime;

    public ZipCodeWilmington() {
        zipCoders = new ArrayList<>();
    }

    public void enroll(Student student) {
        zipCoders.add(student);
    }

    public Boolean isEnrolled(Student student) {

        return zipCoders.contains(student);
    }

    public void lecture(double numberOfHours) {
        for(Student stud:this.zipCoders){
            stud.learn(numberOfHours);
        }

    }

    public Map<Student, Double> getStudyMap() {
        HashMap<Student,Double> studyMap = new HashMap<>();
        for(Student stud:this.zipCoders){
            studyMap.put(stud,stud.getTotalStudyTime());
        }

        return studyMap;
    }
}
