package rocks.zipcode.io.quiz4.generics;

import com.google.common.collect.Sets;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class GenericUtils {

    public static <T extends Comparable> Iterable<? extends Iterable<T>> powerSet(Set<T> originalSet) {
        Set<Set<T>> sets = new HashSet<>();
        if(originalSet.isEmpty()){
            sets.add(new HashSet<>());
            return sets;
        }
        List<T> list = new ArrayList<>(originalSet);
        T head = list.get(0);
        Set<T> rest = new HashSet<>(list.subList(1,list.size()));
        for(Iterable<T> set: powerSet(rest)){
            Set<T> newSet = new HashSet<>();
            newSet.add(head);
            sets.add(newSet);
//            sets.add(set);
        }
        return sets;
    }

    public static <T extends Comparable> Iterable<? extends Iterable<T>> powerSet(T... originalSet) {
        return powerSet(new TreeSet<>(Arrays.asList(originalSet)));
    }
}

